---
title: /v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/{adGroupId}/products/search
slug: campaign-reporting-apis/v2advertisersadvertiseridcampaignscampaignidspaad-groupsadgroupidproductssearch
docTags: 
createdAt: 2026-03-25T10:57:30.256Z
---

{
  "id": "VsgcyvzGJT8MrhAx9h5ON",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/{adGroupId}/products/search",
    "servers": [
      {
        "url": "https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/{adGroupId}/products/search",
        "description": "Generated server url"
      }
    ],
    "name": "",
    "description": "<p>Retrieve products for an SPA ad group.</p>\n<p><strong>Notes:</strong></p>\n<ul>\n<li><em>sortType</em> defaults to ascending if not passed.</li>\n</ul>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [
        {
          "kind": "required",
          "name": "advertiserId",
          "type": "integer<int32>",
          "description": "",
          "format": "int32"
        },
        {
          "kind": "required",
          "name": "campaignId",
          "type": "integer<int32>",
          "description": "",
          "format": "int32"
        },
        {
          "kind": "required",
          "name": "adGroupId",
          "type": "integer<int32>",
          "description": "",
          "format": "int32"
        }
      ],
      "headerParameters": [],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "object",
          "description": "",
          "customType": "ExternalSpaAdGroupProductSearchRequest",
          "schema": [
            {
              "name": "filters",
              "kind": "optional",
              "type": "array",
              "description": "",
              "modelRef": "#/components/schemas/FilterValuesExternalSpaAdGroupProductSearchFilterField",
              "customType": "FilterValuesExternalSpaAdGroupProductSearchFilterField[]",
              "schema": [
                {
                  "name": "field",
                  "kind": "optional",
                  "type": "string<GTIN | BRAND | CATEGORY_ID>",
                  "description": "",
                  "example": "",
                  "enum": [
                    "GTIN",
                    "BRAND",
                    "CATEGORY_ID"
                  ]
                },
                {
                  "name": "values",
                  "kind": "optional",
                  "type": "array",
                  "description": "",
                  "example": "",
                  "itemType": "object",
                  "customType": "object[]",
                  "itemExample": "",
                  "itemDefault": ""
                }
              ]
            },
            {
              "name": "page",
              "kind": "required",
              "type": "integer<int32>",
              "description": "",
              "example": 0,
              "format": "int32",
              "minimum": 0,
              "maximum": 1000
            },
            {
              "name": "limit",
              "kind": "required",
              "type": "integer<int32>",
              "description": "",
              "example": 0,
              "format": "int32",
              "minimum": 1,
              "maximum": 10000
            },
            {
              "name": "sortType",
              "kind": "optional",
              "type": "string<ASC | DESC>",
              "description": "",
              "example": "",
              "enum": [
                "ASC",
                "DESC"
              ]
            },
            {
              "name": "orderBy",
              "kind": "required",
              "type": "string<GTIN | TITLE | BRAND | PRICE | AVAILABILITY | CATEGORY | BID_OPTIMIZATION>",
              "description": "",
              "example": "",
              "enum": [
                "GTIN",
                "TITLE",
                "BRAND",
                "PRICE",
                "AVAILABILITY",
                "CATEGORY",
                "BID_OPTIMIZATION"
              ]
            }
          ],
          "modelRef": "#/components/schemas/ExternalSpaAdGroupProductSearchRequest",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "OK",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ListResponseSpaAdGroupProductSearchResponseVoid",
            "schema": [
              {
                "name": "detailed",
                "kind": "optional",
                "type": "array",
                "description": "",
                "modelRef": "#/components/schemas/SpaAdGroupProductSearchResponse",
                "customType": "SpaAdGroupProductSearchResponse[]",
                "schema": [
                  {
                    "name": "gtin",
                    "kind": "optional",
                    "type": "string",
                    "description": "",
                    "example": ""
                  },
                  {
                    "name": "title",
                    "kind": "optional",
                    "type": "string",
                    "description": "",
                    "example": ""
                  },
                  {
                    "name": "brand",
                    "kind": "optional",
                    "type": "string",
                    "description": "",
                    "example": ""
                  },
                  {
                    "name": "price",
                    "kind": "optional",
                    "type": "number",
                    "description": "",
                    "example": ""
                  },
                  {
                    "name": "availability",
                    "kind": "optional",
                    "type": "string<IN_STOCK | IN_STOCK_REGIONAL | OUT_OF_STOCK | REMOVED>",
                    "description": "",
                    "example": "",
                    "enum": [
                      "IN_STOCK",
                      "IN_STOCK_REGIONAL",
                      "OUT_OF_STOCK",
                      "REMOVED"
                    ]
                  },
                  {
                    "name": "productCategories",
                    "kind": "optional",
                    "type": "array",
                    "description": "",
                    "modelRef": "#/components/schemas/IdNameResponse",
                    "customType": "IdNameResponse[]",
                    "schema": [
                      {
                        "name": "id",
                        "kind": "optional",
                        "type": "integer<int32>",
                        "description": "",
                        "example": 0,
                        "format": "int32"
                      },
                      {
                        "name": "name",
                        "kind": "optional",
                        "type": "string",
                        "description": "",
                        "example": ""
                      }
                    ]
                  },
                  {
                    "name": "advertised",
                    "kind": "optional",
                    "type": "boolean",
                    "description": "",
                    "example": ""
                  },
                  {
                    "name": "bid",
                    "kind": "optional",
                    "type": "number",
                    "description": "",
                    "example": ""
                  },
                  {
                    "name": "bidOptimization",
                    "kind": "optional",
                    "type": "string<MANUAL | CONVERSIONS | BALANCED | AWARENESS>",
                    "description": "Bid optimization enables automated bidding: CONVERSIONS, BALANCED, and AWARENESS set the bid using the lower bound, midpoint, and upper bound of the suggested bid, respectively.\nMANUAL requires setting the bid explicitly.\n",
                    "example": "",
                    "enum": [
                      "MANUAL",
                      "CONVERSIONS",
                      "BALANCED",
                      "AWARENESS"
                    ]
                  }
                ]
              },
              {
                "name": "aggregated",
                "kind": "optional",
                "type": "object",
                "description": "",
                "modelRef": "#/components/schemas/AggregatedVoid",
                "customType": "AggregatedVoid",
                "schema": [
                  {
                    "name": "count",
                    "kind": "optional",
                    "type": "integer<int64>",
                    "description": "",
                    "example": 0,
                    "format": "int64"
                  },
                  {
                    "name": "metrics",
                    "kind": "optional",
                    "type": "",
                    "description": "",
                    "example": ""
                  }
                ]
              }
            ],
            "modelRef": "#/components/schemas/ListResponseSpaAdGroupProductSearchResponseVoid",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "Unauthorized",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "403",
        "description": "Forbidden",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "404",
        "description": "Not Found",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ExceptionResponse",
            "schema": [
              {
                "name": "messages",
                "kind": "optional",
                "type": "array",
                "description": "",
                "example": "",
                "itemType": "string",
                "customType": "string[]",
                "itemExample": "",
                "itemDefault": ""
              }
            ],
            "modelRef": "#/components/schemas/ExceptionResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "422",
        "description": "Unprocessable Entity",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ExceptionResponse",
            "schema": [
              {
                "name": "messages",
                "kind": "optional",
                "type": "array",
                "description": "",
                "example": "",
                "itemType": "string",
                "customType": "string[]",
                "itemExample": "",
                "itemDefault": ""
              }
            ],
            "modelRef": "#/components/schemas/ExceptionResponse",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "w-j83oaOKVLeRdpWc_muY",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/{adGroupId}/products/search \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --data '{\n     \"page\": 0,\n     \"limit\": 0,\n     \"orderBy\": \"\"\n     }'"
        },
        {
          "id": "X1nBSF6TFFe6g94afLuKb",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar raw = JSON.stringify({\n   \"page\": 0,\n   \"limit\": 0,\n   \"orderBy\": \"\"\n});\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/{adGroupId}/products/search\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "20cxHN61f7dQmm9ixHaoj",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/{adGroupId}/products/search\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest.body = JSON.dump({\n   \"page\": 0,\n   \"limit\": 0,\n   \"orderBy\": \"\"\n})\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "aaDTp9DYBQJvIZhYdRa5Y",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://<pcm-domain>/v2/advertisers/{advertiserId}/campaigns/{campaignId}/spa/ad-groups/{adGroupId}/products/search\"\n\npayload = json.dumps({\n   \"page\": 0,\n   \"limit\": 0,\n   \"orderBy\": \"\"\n})\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "w-j83oaOKVLeRdpWc_muY"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-200",
          "language": "200",
          "code": "// OK\n{\n  \"detailed\": [\n    {\n      \"gtin\": \"\",\n      \"title\": \"\",\n      \"brand\": \"\",\n      \"price\": 0,\n      \"availability\": \"\",\n      \"productCategories\": [\n        {\n          \"id\": \"\",\n          \"name\": \"\"\n        }\n      ],\n      \"advertised\": false,\n      \"bid\": 0,\n      \"bidOptimization\": \"\"\n    }\n  ],\n  \"aggregated\": {\n    \"count\": \"\",\n    \"metrics\": \"\"\n  }\n}"
        },
        {
          "id": "response-1-401",
          "language": "401",
          "code": "// Unauthorized\n"
        },
        {
          "id": "response-2-403",
          "language": "403",
          "code": "// Forbidden\n"
        },
        {
          "id": "response-3-404",
          "language": "404",
          "code": "// Not Found\n{\n  \"messages\": [\n    \"\"\n  ]\n}"
        },
        {
          "id": "response-4-422",
          "language": "422",
          "code": "// Unprocessable Entity\n{\n  \"messages\": [\n    \"\"\n  ]\n}"
        }
      ],
      "selectedLanguageId": "response-0-200"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}